#include "timer.h"
#include "led.h"
#include "lwip_comm.h"  // 必须加！否则找不到 lwip_periodic_handle()

TIM_HandleTypeDef TIM3_Handler;      
extern u32 lwip_localtime;	       

// 定时器3初始化：1ms 中断
void TIM3_Init(u16 arr,u16 psc)
{  
    TIM3_Handler.Instance=TIM3;                          
    TIM3_Handler.Init.Prescaler=psc;                     
    TIM3_Handler.Init.CounterMode=TIM_COUNTERMODE_UP;    
    TIM3_Handler.Init.Period=arr;                        
    TIM3_Handler.Init.ClockDivision=TIM_CLOCKDIVISION_DIV1;
    HAL_TIM_Base_Init(&TIM3_Handler);
    
    HAL_TIM_Base_Start_IT(&TIM3_Handler); 
}

void HAL_TIM_Base_MspInit(TIM_HandleTypeDef *htim)
{
    if(htim->Instance==TIM3)
    {
        __HAL_RCC_TIM3_CLK_ENABLE();
        
        // ✅ 最高优先级，保证 LWIP 永不阻塞
        HAL_NVIC_SetPriority(TIM3_IRQn, 0, 0);  
        HAL_NVIC_EnableIRQ(TIM3_IRQn);   
    }
}

void TIM3_IRQHandler(void)
{
    HAL_TIM_IRQHandler(&TIM3_Handler);
}

void HAL_TIM_PeriodElapsedCallback(TIM_HandleTypeDef *htim)
{
    if(htim==(&TIM3_Handler))
    {
        lwip_localtime++;           // ✅ 1ms +1（正确时间）
    }
}
